unit Server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, IPNetwork, ComCtrls, FileCtrl;

type
  TfrmServer = class(TForm)
    Panel1: TPanel;
    ServerMessage: TMemo;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    ServerIPList: TMemo;
    ClientIPList: TMemo;
    BootBtn: TSpeedButton;
    IPServer1: TIPServer;
    Panel4: TPanel;
    DataPanel: TPanel;
    Memo2: TMemo;
		Label5: TLabel;
		DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Panel5: TPanel;
    SendDataBtn: TBitBtn;
    SendFileBtn: TBitBtn;
    Panel6: TPanel;
    Panel7: TPanel;
    Label2: TLabel;
    Panel8: TPanel;
    ProgressBar1: TProgressBar;
    Panel9: TPanel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    ThisIPAddr: TEdit;
    Label6: TLabel;
    procedure BootBtnClick(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
		procedure DirectoryListBox1Change(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure SendFileBtnClick(Sender: TObject);
		procedure SendDataBtnClick(Sender: TObject);
		procedure IPServer1ClientClosed(Sender: TObject; IPAddress: string);
		procedure IPServer1ClientConnect(Sender: TObject; IPAddress: string);
		procedure IPServer1ClientError(Sender: TObject; IPAddress: string;
			ErrorNo: Integer; ErrorMsg: string);
		procedure IPServer1ClientMessage(Sender: TObject; IPAddress: string;
			MsgNo: Integer; Msg: string);
		procedure IPServer1DataReceived(Sender: TObject; IPAddress: string;
			pData: PChar; Size: Integer);
		procedure IPServer1DataSend(Sender: TObject; IPAddress: String;
			pData: PChar; Size, BlockID, TotalProgress: Integer);
		procedure IPServer1Progress(Sender: TObject; ProgressNo: Integer);
		procedure IPServer1FileReceived(Sender: TObject; Filename,
			IPAddress: string);
		procedure IPServer1SendFile(Sender: TObject; Filename,
			IPAddress: string; TotalProgress: Integer);
		procedure IPServer1ServerClosed(Sender: TObject; IPAddress: string);
		procedure IPServer1ServerConnect(Sender: TObject; IPAddress: string);
		procedure IPServer1ServerError(Sender: TObject; IPAddress: string;
			ErrorNo: Integer; ErrorMsg: string);
		procedure IPServer1ServerMessage(Sender: TObject; IPAddress: string;
			MsgNo: Integer; Msg: string);
		procedure IPServer1InitialiseProgress(Sender: TObject; IPAddress: String;
      TotalProgress: Integer);
    procedure ThisIPAddrEnter(Sender: TObject);
    procedure ServerIPListExit(Sender: TObject);
    procedure ClientIPListExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
	private
    { Private declarations }
	public
		{ Public declarations }
	end;

var
	frmServer: TfrmServer;

implementation

{$R *.DFM}

procedure TfrmServer.BootBtnClick(Sender: TObject);
begin
	MessageDlg('Make sure the field ''This IP Address'' is set to the correct'+
		' address used for this network node. If you have more than one TCP/IP'+
		' protocol set up in Windows 95 the first address will be used.',
		mtInformation, [mbOK], 0);

	Timer1.Enabled := False;
	BootBtn.Caption := 'Boot Server';
	ServerIPList.Enabled := False;
	ClientIPList.Enabled := False;
	ThisIPAddr.Enabled := False;
	DataPanel.Enabled := True;
	BootBtn.Enabled := False;

	IPServer1.ClientIPAddrList.Clear;
	IPServer1.ClientIPAddrList.Assign(ClientIPList.Lines);
	IPServer1.ServerIPAddrList.Clear;
	IPServer1.ServerIPAddrList.Assign(ServerIPList.Lines);

	if ThisIPAddr.Text <> '' then
		IPServer1.ThisIPAddr := ThisIPAddr.Text;
	IPServer1.BootServer;
	ThisIPAddr.Text := IPServer1.ThisIPAddr;

	ServerMessage.Lines.Add('Server booted.');
end;

procedure TfrmServer.DriveComboBox1Change(Sender: TObject);
begin
	DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

procedure TfrmServer.DirectoryListBox1Change(Sender: TObject);
begin
	FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TfrmServer.Timer1Timer(Sender: TObject);
begin
	if BootBtn.Caption = 'Boot Server' then
		BootBtn.Caption := ''
	else
		BootBtn.Caption := 'Boot Server';
end;

procedure TfrmServer.SendFileBtnClick(Sender: TObject);
var
	a: Integer;
begin
	if FileListBox1.FileName = '' then
		MessageDlg('Select a file to send.', mtError, [mbOK], 0)
	else
	begin
		MessageDlg('IMPORTANT: The destination directory must be the directory'+
			' name for how the client will see it, not how the server will see it.',
			mtInformation, [mbOK], 0);

		SaveDialog1.InitialDir := DirectoryListBox1.Directory;
		SaveDialog1.FileName := FileListBox1.FileName;
		if SaveDialog1.Execute then
			for a:=1 to ClientIPList.Lines.Count do
				if ClientIPList.Lines[a-1] <> '' then
				begin
					ServerMessage.Lines.Add('Posted file transfer to Client: '+
						ClientIPList.Lines[a-1]+' - '+FileListBox1.FileName);
					IPServer1.SendFileToClient(ClientIPList.Lines[a-1],
						SaveDialog1.FileName, FileListBox1.FileName);
				end;
	end;
end;

procedure TfrmServer.SendDataBtnClick(Sender: TObject);
var
	sText: String;
begin
	SetLength(sText, Memo2.GetTextLen+1);
	Memo2.GetTextBuf(PChar(sText), Memo2.GetTextLen+1);
	sText[Memo2.GetTextLen] := #0;

	// remove carriage returns and linefeeds
	while Pos(#13, sText) > 0 do
		sText[Pos(#13, sText)] := '.';
	while Pos(#10, sText) > 0 do
		sText[Pos(#10, sText)] := '.';
		
	IPServer1.BroadcastDataToAllClients(PChar(sText), Memo2.GetTextLen+1);
//	IPServer1.BroadcastDataToAllServers(PChar(sText), Memo2.GetTextLen+1);
end;

procedure TfrmServer.IPServer1ClientClosed(Sender: TObject;
	IPAddress: string);
begin
	ServerMessage.Lines.Add('A client was closed, will try to reconnect. ['+
		IPAddress+']');
end;

procedure TfrmServer.IPServer1ClientConnect(Sender: TObject;
	IPAddress: string);
begin
	ServerMessage.Lines.Add('A client connected. ['+IPAddress+']');
end;

procedure TfrmServer.IPServer1ClientError(Sender: TObject;
	IPAddress: string; ErrorNo: Integer; ErrorMsg: string);
begin
	ServerMessage.Lines.Add('Client ERROR: '+ErrorMsg);
end;

procedure TfrmServer.IPServer1ClientMessage(Sender: TObject;
	IPAddress: string; MsgNo: Integer; Msg: string);
begin
	ServerMessage.Lines.Add('Client Message: '+Msg);
end;

procedure TfrmServer.IPServer1DataReceived(Sender: TObject;
	IPAddress: string; pData: PChar; Size: Integer);
begin
	pData[Size] := #0;
	ServerMessage.Lines.Add('Data Received. ['+IPAddress+'] - '+pData);
end;

procedure TfrmServer.IPServer1DataSend(Sender: TObject; IPAddress: String;
	pData: PChar; Size,	BlockID, TotalProgress: Integer);
begin
	ServerMessage.Lines.Add('Data Sent. ['+IPAddress+']');
end;

procedure TfrmServer.IPServer1Progress(Sender: TObject;
	ProgressNo: Integer);
begin
	ProgressBar1.Position := ProgressNo;
end;

procedure TfrmServer.IPServer1FileReceived(Sender: TObject; Filename,
	IPAddress: string);
begin
	ServerMessage.Lines.Add('File received and saved: '+Filename+'. ['+IPAddress+']');
	ProgressBar1.Position := 0;
end;

procedure TfrmServer.IPServer1SendFile(Sender: TObject; Filename,
	IPAddress: string; TotalProgress: Integer);
begin
	ServerMessage.Lines.Add('Sending File: '+Filename+'. ['+IPAddress+']');
	ProgressBar1.Position := 0;
	ProgressBar1.Min := 0;
	ProgressBar1.Max := TotalProgress;
end;

procedure TfrmServer.IPServer1ServerClosed(Sender: TObject;
	IPAddress: string);
begin
	ServerMessage.Lines.Add('A server was closed, will try to reconnect. ['+
		IPAddress+']');
end;

procedure TfrmServer.IPServer1ServerConnect(Sender: TObject;
	IPAddress: string);
begin
	ServerMessage.Lines.Add('A server connected. ['+IPAddress+']');
end;

procedure TfrmServer.IPServer1ServerError(Sender: TObject;
	IPAddress: string; ErrorNo: Integer; ErrorMsg: string);
begin
	ServerMessage.Lines.Add('Server ERROR: '+ErrorMsg);
end;

procedure TfrmServer.IPServer1ServerMessage(Sender: TObject;
	IPAddress: string; MsgNo: Integer; Msg: string);
begin
	ServerMessage.Lines.Add('Server Message: '+Msg);
end;

procedure TfrmServer.IPServer1InitialiseProgress(Sender: TObject;
	IPAddress: String; TotalProgress: Integer);
begin
	ServerMessage.Lines.Add('Receiving Data/File. ['+IPAddress+']');
	ProgressBar1.Position := 0;
	ProgressBar1.Min := 0;
	ProgressBar1.Max := TotalProgress;
end;

procedure TfrmServer.ThisIPAddrEnter(Sender: TObject);
begin
	if ThisIPAddr.Text = '' then
		ThisIPAddr.Text := IPServer1.GetThisServerIPAddr;
end;

procedure TfrmServer.ServerIPListExit(Sender: TObject);
begin
	ChDir(ExtractFilePath(Application.ExeName));
	ServerIPList.Lines.SaveToFile('ServerIPList.DAT');
end;

procedure TfrmServer.ClientIPListExit(Sender: TObject);
begin
	ChDir(ExtractFilePath(Application.ExeName));
	ClientIPList.Lines.SaveToFile('ClientIPList.DAT');
end;

procedure TfrmServer.FormShow(Sender: TObject);
begin
	ChDir(ExtractFilePath(Application.ExeName));
	if FileExists('ServerIPList.DAT') then
		ServerIPList.Lines.LoadFromFile('ServerIPList.DAT');
	if FileExists('ClientIPList.DAT') then
		ClientIPList.Lines.LoadFromFile('ClientIPList.DAT');
end;

end.
